//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fakefra2_Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
TForm1::cWormDance::cWormDance(int argnWorms, TImage * & argimage, int argside)
{
        nWorms = argnWorms;
        worm = new cWorm[nWorms];
        image = argimage;
        side = argside;
        width = image->Width / side;
        height = image->Height / side;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        delete wormDance;
        int
                nWorms = StrToInt(eNWorms->Text),
                side = StrToInt(eSide->Text),
                maxLength = StrToInt(eMaxLength->Text);
        float
                rcRange = StrToFloat(eRcRange->Text);
        wormDance = new cWormDance(nWorms, Image1, side);
        for (int n = 0; n < wormDance->nWorms; n++)
        {
                wormDance->worm[n].define(wormDance->width, wormDance->height, maxLength, rcRange);
                wormDance->worm[n].init();
        }
        wormDance->wormLove();
        wormDance->draw();
        chaosTimer->Interval = StrToInt(eInterval->Text);
        chaosTimer->Enabled = !CBSingle->Checked;
}
//---------------------------------------------------------------------------
TForm1::cWorm::cWorm()
{
}
//---------------------------------------------------------------------------
int TForm1::cWorm::indexOf(int r, int c)
{
        int
                index = r * width + c;
        return index;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
        DecimalSeparator = '.';
        wormDance = 0;
}
//---------------------------------------------------------------------------
void TForm1::cWorm::adjust()
{
        int
                initialDR = -1 + 2 * (rand() % 2),
                initialDC = -1 + 2 * (rand() % 2);
                recurse1(startVal, lineRow, lineColumn, maxLength, rc,
                        initialDR, initialDC);
}
//---------------------------------------------------------------------------
void TForm1::cWorm::define(int argwidth, int argheight, int argmaxLength,
        float argrcRange)
{
        width = argwidth;
        height = argheight;
        maxLength = argmaxLength;
        rcRange = argrcRange;
        lineRow = height / 2;
        lineColumn = width / 2;
        points = new float[width * height];
        rc = 2.0 * M_PI * (float)(rand() % 10) / 10.0;
        startVal = 1.0;
}
//---------------------------------------------------------------------------
void TForm1::cWorm::init()
{
        for (int n = 0; n < height; n++)
        {
                for (int m = 0; m < width; m++)
                {
                        points[indexOf(n, m)] = 0 * (float)(rand() % 100) / 100.0;
                }
        }
}
//---------------------------------------------------------------------------
void TForm1::cWorm::recurse1(float lastVal, int row, int column, int lengthLeft,
        float & rc, int lastDR, int lastDC)
{
        if (lastVal < 0.1)
        {
                return;
        }
        int
                index = indexOf(row, column);
        points[index] += lastVal;
        checkValue(points[index]);
        if (lengthLeft % maxLength != 0)
        {
                lengthLeft++;
                int
                        dRow = lastDR,
                        dColumn = lastDC,
                        thisRow = row + dRow,
                        thisColumn = column + dColumn;
                checkBoundaries(thisRow, thisColumn);
                float
                        reduction = rcRange * (float)(rand() % 2),
                        thisVal = lastVal;
                checkValue(thisVal);
                recurse1(thisVal, thisRow, thisColumn, lengthLeft, rc,
                        dRow, dColumn);
        }
        else
        {
        lengthLeft++;
        for (int dRow = -1; dRow <= 1; dRow++)
        {
                for (int dColumn = -1; dColumn <= 1; dColumn++)
                {
                        if ((dColumn == 0 && dRow == 0))
                        {
                                continue;
                        }
                        int
                                dH = abs(dColumn - lastDC),
                                dR = abs(dRow - lastDR);
                        if (dH + dR > 1)
                        {
                                continue;
                        }
                        int
                                thisRow = row + dRow,
                                thisColumn = column + dColumn;
                        checkBoundaries(thisRow, thisColumn);
                        float
                                reduction = rcRange * (float)(rand() % 2),
                                thisVal = lastVal * reduction;
                        checkValue(thisVal);
                        recurse1(thisVal, thisRow, thisColumn, lengthLeft, rc,
                                dRow, dColumn);
                }
        }
        } // if lengthLeft % maxLength == 0
}
//---------------------------------------------------------------------------
void TForm1::cWormDance::draw()
{
        for (int n = 0; n < height; n++)
        {
                for (int m = 0; m < width; m++)
                {
                        float
                                maxVal = 0,
                                sum = 0;
                        int
                                index = worm[0].indexOf(n, m),
                                maxIndex = 0,
                                nWormPoints = 0;
                        for (int i = 0; i < nWorms; i++)
                        {
                                float
                                        val = worm[i].points[index];
                                sum += val;
                                if (val > 0.1)
                                {
                                        nWormPoints++;
                                }
                                if (maxVal < val)
                                {
                                        maxVal = val;
                                        maxIndex = i;
                                }
                        }
                        if (nWormPoints > 0)
                        {
                                sum /= nWormPoints;
                        }
                        image->Canvas->Brush->Color = getColor(maxVal, maxIndex % 3);
                        image->Canvas->FillRect(Rect(n * side, m * side, n * side + side, m * side + side));
                }
        }
}
//---------------------------------------------------------------------------
TColor TForm1::cWormDance::getColor(float val, int n)
{
        int
                col[3];
        col[0] = 0,
        col[1] = 0,
        col[2] = 0;
        col[1] = (int)(255.0 * val);
        col[2] = (int)(255.0 * (val - 0.3));
        col[0] = (int)(255.0 * (val - 0.6));
        for (int n = 0; n < 3; n++)
        {
                if (Form1->CBWhite->Checked == true)
                {
                        col[n] = (int)(255.0 * val);
                }
                if (col[n] < 0)
                {
                        col[n] = 0;
                }
                if (col[n] > 255)
                {
                        col[n] = 255;
                }
        }
        AnsiString
                colString = "$" + IntToHex(col[0], 4) + IntToHex(col[1], 2) +
                        IntToHex(col[2], 2);
        return StringToColor(colString);
}
//---------------------------------------------------------------------------
void TForm1::cWormDance::fade()
{
        float
                fadeFactor = StrToFloat(Form1->eFadeFactor->Text);
        if (fadeFactor == 0)
        {
                return;
        }
        for (int i = 0; i < nWorms; i++)
        {
        for (int n = 0; n < height; n++)
        {
                for (int m = 0; m < width; m++)
                {
                        worm[i].points[worm[i].indexOf(n, m)] /= fadeFactor;
                }
        }
        }
}
//---------------------------------------------------------------------------
void TForm1::cWormDance::wormLove()
{
        for (int i = 0; i < nWorms; i++)
        {
                for (int j = 0; j < i; j++)
                {
                        if (i == j)
                        {
                                continue;
                        }
                        float
                                xi = worm[i].lineRow,
                                xj = worm[j].lineRow,
                                yi = worm[i].lineColumn,
                                yj = worm[j].lineColumn,
                                dy = (yj - yi),
                                dx = (xj - xi),
                                targetRc;
                        if (dx == 0)
                        {
                                targetRc = M_PI / 4.0;
                                if (dy < 0)
                                {
                                        targetRc *= -1;
                                }
                        }
                        else
                        {
                                targetRc = atan(dy / dx);
                                if (dx < 0)
                                {
                                        targetRc += M_PI;
                                }
                        }
                        if (Form1->CBWormhate->Checked == true)
                        {
                                targetRc += M_PI;
                        }
                        targetRc = fmod(targetRc + 2.0 * M_PI, 2.0 * M_PI);
                        cWorm
                                *wormI = &worm[i],
                                *wormJ = &worm[j];
                        wormI->rc = (wormI->rc + targetRc) / 2.0;
                        targetRc = fmod(targetRc - M_PI, 2.0 * M_PI);
                        wormJ->rc = (wormJ->rc + targetRc) / 2.0;
                }
                worm[i].adjust();
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::chaosTimerTimer(TObject *Sender)
{
        wormDance->fade();
        wormDance->wormLove();
        wormDance->draw();
}
//---------------------------------------------------------------------------
void TForm1::cWorm::checkBoundaries(int & row, int & column)
{
        if (Form1->CBBoundaries->Checked == true)
        {
                if (row < 0)
                {
                        row = 0;
                }
                if (row >= height)
                {
                        row = height - 1;
                }
                if (column < 0)
                {
                        column = 0;
                }
                if (column >= width)
                {
                        column = width - 1;
                }
        }
        else
        {
                if (row < 0)
                {
                        row += height;
                }
                row %= height;
                if (column < 0)
                {
                        column += width;
                }
                column %= width;
        }
}
//---------------------------------------------------------------------------
void TForm1::cWorm::checkValue(float & val)
{
        if (Form1->CBCircular->Checked)
        {
                if (val < 0.0)
                {
                        val += 1.0;
                }
                val = fmod(val, 1.0);
        }
        else
        {
                if (val < 0.0)
                {
                        val = 0;
                }
                if (val > 1.0)
                {
                        val = 1.0;
                }
        }
}
//---------------------------------------------------------------------------

